#include <bits/stdc++.h>

using namespace std;

void pntok() {
    cout << "1.0" << endl;
    cerr << "translate:success" << endl;
    exit(0);
}

void pntwa() {
    cout << "0.0" << endl;
    cerr << "translate:wrong" << endl;
    exit(0);
}

struct Eq {
    int u, v;
    int m;
};

constexpr int MIN_V = -1000000000;
constexpr int MAX_V =  1000000000;

int main(int argc, char *argv[]) {
    assert(argc == 4);

    ifstream input(argv[1]);
    ifstream ref_output(argv[2]);
    ifstream user_output(argv[3]);

    string ref_start;
    ref_output >> ref_start;
    if(ref_start == "nelze") {
        string user_start;
        if(!(user_output >> user_start)) pntwa();
        if(user_start == "nelze") {
            pntok();
        } else {
            pntwa();
        }
    }

    int t, o;
    input >> t >> o;

    vector<Eq> eqs;

    for(int i = 0; i < o; ++i) {
        int u, v, m;
        input >> u >> v >> m;
        eqs.push_back({u-1, v-1, m});
    }


    vector<int> pos(t);
    for(int i = 0; i < t; ++i) {
        int v;
        if(!(user_output >> v)) {
            pntwa();
        }
        if(v > MAX_V || v < MIN_V) {
            pntwa();
        }
        pos[i] = v;
    }


    for(auto[u, v, m] : eqs) {
        if(pos[u] < pos[v] + m) pntwa();
    }

    pntok();
    return 0;
}
