#include <stdio.h>
#include <vector>

using namespace std;

struct restriction {
    int t1, t2, m;   
};

const int MAX_TRIES = int(5e5);

int main() {
    int n, o;
    scanf("%d %d ", &n, &o);

    vector<int> times(n, 0);
    vector<restriction> restrictions(o);
    for (int i=0; i<o; i++) {
        int t1, t2, m;
        scanf("%d %d %d ", &t1, &t2, &m);
        restrictions[i] = {t1-1, t2-1, m};
    }

    int tries=0;
    while (++tries < MAX_TRIES) {
        bool ok = true;
        for (auto r: restrictions) {
            if (times[r.t1] > int(1e9)) goto nelze;
            if (!(times[r.t1] >= times[r.t2] + r.m)) {
                times[r.t1] = times[r.t2] + r.m;
                ok = false;
                break;
            }
        }
        if (ok) break;
    }

    if (tries >= MAX_TRIES) {
        nelze: printf("nelze");
    } else {
        for (int i=0; i<n; i++) {
            printf("%d ", times[i]);
        }
    }
    printf("\n");
}
